# -*- coding: ISO-8859-1 -*-
#-------------------------------------------------------------------------------
# $Id$
#
# Copyright 2016 Jean-Luc PLOIX
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#-------------------------------------------------------------------------------1
'''
Created on 20 feb 2017

@author: jeanluc
'''
TAG = "dev"
VERSION_MAJOR = 18
VERSION_MINOR = 5
VERSION_MAINTENANCE = 28
VERSION_BUILD = 0

# history # 

# 18.5.28.0  new get_results_from_smiles in api.run
# 18.5.26.0  remise en ordre des sauvega    rdes wush
# 18.5.25.3  idem
# 18.5.25.2  fix bug in usage NN without id and target
# 18.5.25.1  usage decimal without data to 2
# 18.5.25.0  usage decimal piloted by target string
# 18.5.24.3  back to cython
# 18.5.24.2  back to cython
# 18.5.24.1  no cython
# 18.5.24.0  use wheel everywhere
# 18.5.23.2  version back to cython
# 18.5.23.1  version no_cython
# 18.5.22.0  remove versions in install requires
# 18.5.19.0  full installrequire
# 18.5.18.1  change modeltemplate to start with 'zzz'
# 18.5.18.0  fix bug in indexing files in GM create model
# 18.5.17.1  fix bug in default init with @ argfile calling
# 18.5.17.0  fix bug in finishExcel
# 18.5.16.1  fix bug in finishExcel
# 18.5.16.0  fix dockerfiles nn1_base
# 18.5.15.8  still working on dependencies
# 18.5.15.4 remove dependencylinks from setup
# 18.5.15.1  remove import futures from nntoolbox.setup.py
# 18.5.15.0  remove import futures
# 18.5.12.4  DEBUG RUN
# 18.5.12.3  DEBUG RUN
# 18.5.12.1  fix bug SF_CODE -> SF_CCODE in _driver
# 18.5.12.0  OK nn1 api interface and demo jupyter
# 18.4.23.0  set api as module
# 18.4.21.5  fix bug in options.yesyes not initialized
# 18.4.21.4  OK test argfile creation
# 18.4.21.3  fix nntoolbox.utils.getListFromStr to accept None input
# 18.4.21.1  display argfile name in correct reference
# 18.4.21.0  display LOO inspected
# 18.4.20.0  clarify init options
# 18.4.19.1  manage errors in usage
# 18.4.19.1  fix bug startswith in nn1_api_service.prepareUsageAction
# 18.4.19.0  random init for trainjob back to the old method
# 18.4.18.7  cosmetic
# 18.4.18.6  cosmetic
# 18.4.18.3  accept ';' as separator for group^count and grouplist
# 18.4.18.3  cosmetic
# 18.4.18.2  send to sys.stderr error messages that stop
# 18.4.18.1  cosmetic display
# 18.4.17.9  modif utils.callerView to remove /home/ from displayed filenames
# 18.4.17.8  modif utils.callerView to remove /home/ from displayed filenames
# 18.4.17.7  fix typing error
# 18.4.17.6  adjust result displazy for verbose = 2
# 18.4.17.5  display basename for input files
# 18.4.17.3  fix bug DEMO_DEBUG_FOLDER
# 18.4.17.2  fix bug results display internal folder
# 18.4.17.1  fix bug "/docker" in nntoolbox/utils
# 18.4.17.0  change internal excvhange folder from /docker to /home
# 18.4.16.3  full version display for VERSION fixed
# 18.4.16.0  full version display for VERSION fixed
# 18.4.15.3  ful version display for VERSION
# 18.4.15.2  modernize monalrecords
# 18.4.15.1  init xml=None in getModelDict
# 18.4.15.0  supp modeldata from nnx
# 18.4.14.0  check modelCount in existing training models
# 18.4.12.0  extend search input files on all children of shared folder
# 18.4.11.3  reading hostpath from docker in host.pth ...
# 18.4.11.0  reading hostpath from docker in host.pth
# 18.4.10.3  OK fullH
# 18.4.10.2  check csv data foermat
# 18.4.10.1  change static lib file names more specific
# 18.4.10.0  fix bug erase tempdir before compiling
# 18.4.9.4   supp '-D_FILE_OFFSET_BITS=64' in compile dll
# 18.4.9.3   declarations extern en C 3
# 18.4.9.2   declarations extern en C 2
# 18.4.8.1   declarations extern en C
# 18.4.8.0   track bug testH
# 18.4.6.3   main tra    in back to parallel
# 18.4.6.2   init seed in LOO indexed on init and no longer on training example
# 18.4.6.1   train with H atoms
# 18.4.6.0   accept H atoms froim smiles
# 18.4.5.2   fix loo save
# 18.4.5.0   fix usage multi display
# 18.4.4.14 reprise usage gm
# 18.4.4.5  OK usage with few parameters
# 18.4.4.0   sqlfilename and sqlLOOfilename in excel file
# 18.4.3.6   fix resultFrame call and recall
# 18.4.3.4   fix loo decor and resultFrame recall
# 18.4.3.3   fix decor empty
# 18.4.3.2   fix decorfile
# 18.4.3.1   fix bug in getSaveDictMulti
# 18.4.3.0   fix bug loo only
# 18.3.29.0  set usage mode - 1
# 18.3.26.0  debug tootest + modif random initia    lization in parallel jobs
# 18.3.24.3  bug fix in nn12_api_service.getLOOFrame
# 18.3.24.3  mean field in lootrain
# 18.3.24.2  debug ordered col in lootrain
# 18.3.24.1  debug ordered col in lootrain false
# 18.3.24.0  debug indexation des lootrain sur excel
# 18.3.23.0  debug test results indexings
# 18.3.22.5  debug normalisation des modles en test (nn1 et gm)
# 18.3.22.2  debug gm test
# 18.3.22.2  debig lootest for gm projects - dont work for nn projects
# 18.3.22.0  relax select in loo if looinittype != 2
# 18.3.21.1  ajout de '-D_FILE_OFFSET_BITS=64' dans les azrguments de compilation du module dynamique
# 18.3.21.0  fix bug in seed init in parallel jobs (std anf LOO-BS)
# 18.3.20.3  fix bug on setidentifier in C code
# 18.3.20.1  modif use of SHAREFOLDER for retrieving data files
# 18.3.20.0  bug on gm molecules display - use #define _FILE_OFFSET_BITS  64 in dll C code - nn1 OK (dev) on train, test, loo for nn and gm
# 18.3.16.0  intro of chem_gm in nn1 requireents
# 18.3.15.5  add chem_gm in dependancies
# 18.3.15.4  add chem_gm in dependancies
# 18.3.15.3  fix library compile, including monal lib
# 18.3.15.0  fix sql selection results, multi compile
# 18.3.14.0 blocksize variable in multimodel compile - display local seed in training
# 18.3.5.1 no input type checking
# 18.3.5.0 optimisation C code
# 18.3.2.1 fix bug in compile multimodels aftder modif of compile_lib
# 18.3.2.0 fix LOO bug in loo models selection
# 18.3.1.0  modif code C for memory blocking
# 18.2.9.0  rewrite inputs selection
# 18.2.8.2  suggest full decor
# 18.2.8.0  revisit input selection wth gramm-schmidt
# 18.2.2.3  follow monal 18.2.2.1  follow nntoolbox 18.2.2.1  relax openpyxl version requirement
# 1.0.2.28 follow monal 7.0.2.25 extract _driverlib from cython
# 1.0.2.25 follow monal 7.0.2.22 extract monal/datareader/fileInspect from cython
# 1.0.2.22 cvheck if datafieldlist is None or not len(datafieldlist): in NN1_API.AnalyseDataFiles
# 1.0.2.21 follow monal 7.0.2.21 preceeding without monal/model
# 1.0.2.20 follow monal 7.0.2.19 preceeding + monal/model except _network, _node, _link, _modelfunc
# 1.0.2.18 follow monal 7.0.2.18 preceeding + monal/model except _network, _node, _link
# 1.0.2.17 follow monal 7.0.2.17 preceeding + monal/model except _network
# 1.0.2.16 follow monal 7.0.2.16 preceeding + monal/model
# 1.0.2.15 follow monal 7.0.2.15 preceeding + monal/library
# 1.0.2.14 follow monal 7.0.2.13 preceeding + monam/driver in cythonlist except networkfactory, drivermultidyn, parallelJobs
# 1.0.2.13 follow monal 7.0.2.13 preceeding + monam/driver in cythonlist except networkfactory, drivermultidyn
# 1.0.2.12 follow monal 7.0.2.12 preceeding + monam/driver in cythonlist except networkfactory
# 1.0.2.11 follow monal 7.0.2.11 preceeding + monam/driver in cythonlist
# 1.0.2.10 follow monal 7.0.2.10  add all monal/datareader monal/lcode monal/util*.py to cythonlist except monal/util/utils.py
# 1.0.2.9  follow monal 7.0.2.9  add all monal/datareader monal/lcode monal/util*.py to cythonlist
# 1.0.2.8  follow monal 7.0.2.8  add all monal/datareader monal/lcode monal/model*.py to cythonlist
# 1.0.2.7  follow monal 7.0.2.7  add all monal/datareader monal/lcode *.py to cythonlist
# 1.0.2.6  follow monal 7.0.2.6  add all monal/datareader *.py to cythonlist
# 1.0.2.5  follow monal 7.0.2.5  add all monal *.py to cythonlist
# 1.0.2.4  follow monal 7.0.2.4  follow nntoolbox 1.0.2.4  full cython on nntoolbox
# 1.0.2.3   follow monal 7.0.2.3  follow nntoolbox 1.0.2.2 cython on nntoolbox ote filetoolbox
# 1.0.2.2   follow monal 7.0.2.2  follow nntoolbox 1.0.2.2  cython on nntoolbox
# 1.0.2.1   follow monal  7.0.2.1  follow nntoolbox 1.0.2.1   pandas > 0.21.0 => set_value, get_value depreecated
# 1.0.2.0   basic woth no cython proptection
# 1.0.1.17  follow monal 7.0.1.15 follow nntoolbox 1.0.1.12 fix bug in cleanup
# 1.0.1.16  follow monal 7.0.1.14 follow nntoolbox 1.0.1.11 fix bug in setup
# 1.0.1.15  follow monal 7.0.1.13 follow nntoolbox 1.0.1.10 new setup
# 1.0.1.14  follow monal 7.0.1.12 follow nntoolbox 1.0.1.9  fix bug in configparsertoolbox
# 1.0.1.13  follow monal 7.0.1.11 follow nntoolbox 1.0.1.8  return to setup process
# 1.0.1.12  follow monal 7.0.1.10 follow nntoolbox 1.0.1.7  no arguments at all 2
# 1.0.1.11  add cmd line in analyse output
# 1.0.1.10  add cmd line in analyse output
# 1.0.1.8  follow monal 7.0.1.9 follow nntoolbox 1.0.1.6  no arguments at al
# 1.0.1.7  follow monal 7.0.1.6 follow nntoolbox 1.0.1.5  fix bug test only
# 1.0.1.6  follow monal 7.0.1.5
# 1.0.1.3  fix bug import in n1_apidemo
# 1.0.1.2 follow monal 7.0.1.3
# 1.0.1.1 follow monal 7.0.1.2 follow nntoolbox 1.0.1.2
# 1.0.1.0 follow monal 7.0.1.0 follow nntoolbox 1.0.1.0  first OK of nn1 in docker
# 1.0.0.8 follow monal 7.0.0.10 add 'magic' in required in setup
# 1.0.0.7 fix nn1_api_service 
# 1.0.0.6 fix n1_apidemo
# 1.0.0.5 add required xlsxwriter in setup
# 1.0.0.4 follow monal 7.0.0.9  follow nntoolbox 1.0.0.20 clean filetoolbox
# 1.0.0.3 follow monal 7.0.0.3  follow nntoolbox  1.0.0.3
# 1.0.0.2 follow monal 7.0.0.2  follow nntoolbox  1.0.0.2 add average data on test chart
# 1.0.0.1 follow monal 7.0.0.1  follow nntoolbox 1.0.0.1 fix bug in excelutils (index in test chart)
# 1.0.0.0 follow monal 7.0.0.0 nntoolbox 1.0.0.0  OK first NN1
# 0.1.0.2 follow monal 4.3.1.78 Ok for gm_api use existing modelsLarten3556

# 0.1.0.1 follow monal 4.3.1.70 isnan bug fixed
# 0.1.0.0 create monal/api
 

__version__ = "%d.%d.%d.%d" % (VERSION_MAJOR, VERSION_MINOR, VERSION_MAINTENANCE, VERSION_BUILD)
VERSION3 = "%d.%d.%d" % (VERSION_MAJOR, VERSION_MINOR, VERSION_MAINTENANCE)
VERSION2 = "%d.%d" % (VERSION_MAJOR, VERSION_MINOR)
if TAG:
    __version__ = "{0}.{1}{2}".format(VERSION3, TAG, VERSION_BUILD)
version = lambda: __version__

def distname(path="", ext=".tar.gz"):   
    import os
    st = "nn1-%s%s"% (__version__, ext)
    if len(path):
        st = os.path.join(path, st)
    return st
